/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 776 2011-01-31 14:14:07Z ertl-honda $
 */

/*
 * åװ¸⥸塼AT91SKYEYEѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"
#include "mp.h"
#include <stdlib.h>

#ifdef TOPPERS_ENABLE_TRACE
#include <stdio.h>
static FILE *trace_log_file;
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ʸνϡʥСåѡ
 */
static void
target_fput_str(char *c) {
	while(*c != '\0') {
		at91skyeye_putc(*c++);
	}
}

/*
 *   to ʸѴ(4bit)
 */
static char
num_to_char(uint8_t num) {
	if (num <= 9) {
		return ('0' + num);
	}
	else {
		return ('a' + (num - 10));
	}
}

/*
 *  Сֹν
 */
static void
version_put(uint16_t version) {
	char c;

	c = num_to_char((version >> 12) & 0x0f);
	at91skyeye_putc(c);
	at91skyeye_putc('.');
	c = num_to_char((version >> 8) & 0x0f);
	at91skyeye_putc(c);
	c = num_to_char((version >> 4) & 0x0f);
	at91skyeye_putc(c);
	at91skyeye_putc('.');
	c = num_to_char((version) & 0x0f);
	at91skyeye_putc(c);
	at91skyeye_putc('.');
}

/*
 *  Сå
 */
static void
version_check(void) {

	/* SkyEye ΥСǧ */
	if (sil_rew_mem((void *)(SKYEYE_VER_REG)) != SUPPORT_SKYEYE_VER) {
		target_fput_str("SkyEye version is mismatch!!");
		at91skyeye_putc('\n');
		target_fput_str("Suppoted version is ");
		version_put(SUPPORT_SKYEYE_VER);
		at91skyeye_putc('\n');
		target_fput_str("Tool version is ");
		version_put(sil_rew_mem((void *)(SKYEYE_VER_REG)));
		at91skyeye_putc('\n');
		target_fput_str("Kernel Exit...");
		at91skyeye_putc('\n');
		target_exit();
	}

	/* DeviceManger Extension ΥСǧ */
	if ((sil_rew_mem((void *)(DEVM_VER_REG)) & 0xfff0)
		!= (SUPPORT_DEVM_VER & 0xfff0)) {
		target_fput_str("DeviceManager Extension version is mismatch!!");
		at91skyeye_putc('\n');
		target_fput_str("Suppoted version is ");
		version_put(SUPPORT_DEVM_VER);
		at91skyeye_putc('\n');
		target_fput_str("Tool version is ");
		version_put((sil_rew_mem((void *)(DEVM_VER_REG)) & 0xfff0));
		at91skyeye_putc('\n');
		target_fput_str("Kernel Exit...");
		at91skyeye_putc('\n');
		target_exit();
	}
}

/*
 *  str_ker() ǥޥץåǹԤ
 */
void
target_mprc_initialize(void)
{

}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	TPCB *p_tpcb = get_my_p_tpcb();
	uint32_t index = x_prc_index();

	/*
	 *  target_fput_log ǽˤʤ褦UART
	 */
	at91skyeye_init_uart(x_prc_index() + 1);

	/*
	 *  Сγǧ
	 */
	version_check();

	/*
	 *  ARM¸ν
	 */
	core_initialize();
    
	/*
	 * Ƴߤγ׵ػߥե饰ػ
	 */
	p_tpcb->idf = ~0U;

	/*
	 * ͥ٥ޥ0
	 */ 
	p_tpcb->ipm = 0U;

	/*
	 * Ƥγߤޥ
	 */ 
	at91skyeye_disable_int(~0U);

	/*
	 * Ƥγװ򥯥ꥢ
	 */
	at91skyeye_clear_int(~0U);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
	 */
	p_tpcb->bitpat_cfgint = 0U;
    
	/*
	 *  ߥޥơ֥ؤΥݥ󥿤ν
	 */
	p_tpcb->p_ipm_mask_table = p_ipm_mask_table[index];

	/*
	 *  ߥϥɥơ֥ؤΥݥ󥿤ν
	 */
	p_tpcb->p_inh_table = p_inh_table[index];

	/*
	 *  ͥ٥ơ֥ؤΥݥ󥿤ν
	 */
	p_tpcb->p_inh_ipm_table = p_inh_ipm_table[index];

#ifdef TOPPERS_ENABLE_TRACE
	if (x_sense_mprc()) {
		trace_log_file = fopen("kernel.log","w");
	}
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  exit()κǸ˸ƤӽФؿSkyEyeλ롥
 *  ޥץåʳƤӽФ
 */
extern void _exit(int) NoReturn;

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  ٤Ƥγߤޥ롥
	 */
	at91skyeye_disable_int(~0U);

	/*
	 *  ARM¸νλ
	 */
	core_terminate();

	/*
	 *  ȯĶ¸νλ
	 */
	at91skyeye_exit();

#ifdef TOPPERS_ENABLE_TRACE
	if (x_sense_mprc()) {
		fclose(trace_log_file);
	}
#endif /* TOPPERS_ENABLE_TRACE */

#ifdef TOPPERS_ENABLE_GCOV_PART
	_exit(0);
#else /* TOPPERS_ENABLE_GCOV_FULL */
	if (x_sense_mprc()) {
		exit(0);
	}
	else {
		_exit(0);
	}
#endif /* TOPPERS_ENABLE_GCOV_PART */
}

/*
 *  ¹Իʬ۽ץ⥸塼Ѥ¬ѥޤνؿ
 */
void
perf_timer_initialize(intptr_t exinf)
{
}

/*
 *  륫󥿤μ
 */
void
cycle_counter_get(uint32_t *p_time)
{
	*p_time = cycle_counter_get_current();
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		at91skyeye_putc('\r');
	}
	at91skyeye_putc(c);
}

#ifdef TOPPERS_ENABLE_TRACE
/*
 *  ȥ졼Υե
 */
void
target_fput_log_file(char_t c)
{
	if (c == '\n') {
		fputc('\r', trace_log_file);
	}
	fputc(c, trace_log_file);
}
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ׵饤°
 *
 *  FMPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask)
{
	TPCB *p_tpcb = get_my_p_tpcb();

	assert(VALID_INTNO_CFGINT(ID_PRC(x_prc_index()), intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	p_tpcb->bitpat_cfgint |= INTNO_BITPAT(INTNO_MASK(intno));
    
	/* 
	 * äߤػߤ
	 */    
	x_disable_int(intno);

	if ((intatr & TA_ENAINT) != 0U){
		(void)x_enable_int(intno);
	}    
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "Processor %d : Unregistered Interrupt occurs.", prc_id);
	target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */


extern void start_master(void);

/*
 *  ѥΥȥåץ롼󤫤ƤӽФ롥
 *  sta_ker()ƤӽФƥͥ򥹥Ȥ롥 
 */
int
main(void)
{
	start_master();
	return 1;
}

#ifdef TOPPERS_ENABLE_GCOV_PART
/*
 *  GCOVѥ饤֥
 */

extern void __gcov_flush();

/*
 *  GCOVؿ
 *   Хå.gcda˽ϤSkyEye*.gcdaե롥
 */
void
gcov_init(void)
{
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	__gcov_flush();
	sil_wrw_mem((void*)0xFFFE1020, 0);
	SIL_UNL_SPN();
}

/*
 *  GCOVǴؿ
 *   Хå.gcda˽ϤSkyEye*.gcdaե*.gcda.bakإ͡ह롥
 */
void
gcov_pause(void)
{
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	__gcov_flush();
	sil_wrw_mem((void*)0xFFFE1024, 0);
	SIL_UNL_SPN();
}

/*
 *  GCOVƳؿ
 *   Хå.gcda˽ϤSkyEye*.gcda.bakե*.gcdaإ͡ह롥
 */
void
gcov_resume(void)
{
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	__gcov_flush();
	sil_wrw_mem((void*)0xFFFE1028, 0);
	SIL_UNL_SPN();
}

/*
 *  GCOVϴؿ
 *   Хå.gcda˽Ϥ롥
 */
void
gcov_dump(void)
{
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	__gcov_flush();
	SIL_UNL_SPN();
}
#endif /* TOPPERS_ENABLE_GCOV_PART */
